/*
 * Note to CS70 students: this is an incomplete source file.  You must
 * complete it as you feel appropriate.  Search for "ADD STUFF" to
 * find places you *MAY* need to change.
 *
 * Note that many comments are missing.  We have not provided "ADD
 * STUFF" hints for missing comments.
 */

/*
 * Name: Geoff Kuenning
 * Course: CS 70, Fall 2002
 * Assignment #3
 */

#include "course.hh"
#include "student.hh"
#include <iostream>
#include <string>

using namespace std;

/* 
 * Table of Contents: the following routines are defined in this file:
 *
 *			Course::Course();
 *			Course::Course(const string department_,
 *			  int courseNumber_, const string meetingTime_,
 *			  int maxEnrollment_);
 *					// Construct from parameters
 *			Course::~Course();
 * void			Course::fillInInfo(const string department_,
 *			  int courseNumber_, const string meetingTime_,
 *			  int maxEnrollment_);
 *					// Set or change course info
 * bool			Course::isFull() const;
 *					// Return true if course is at
 *					// ..maximum enrollment
 * bool			Course::courseIs(const string testDepartment,
 *			  int testNumber) const;
 *					// Return true if course department
 *					// ..and number match parameters
 * bool			Course::addStudent(Student* enrollee);
 *					// Add a student to the course,
 *					// ..possibly also adding the course
 *					// ..to student's schedule
 *					// ..[depending on implementation].
 *					// ..Return true if add was
 *					// ..successful, false if not done
 *					// ..(e.g., student already in
 *					// ..course)
 * void			Course::removeStudent(Student* dropper);
 *					// Remove a student from the course,
 *					// ..possibly also removing the
 *					// ..course from student's schedule
 *					// ..[depending on implementation].
 *					// ..Returns true if remove was
 *					// ..successful, false otherwise
 *					// ..(e.g., student wasn't in the
 *					// ..course)
 * void			Course::changeMeetingTime(string newMeetingTime);
 *					// Reschedule course
 * ostream&		Course::showName(ostream& targetStream) const;
 *					// Display course name on a stream
 * ostream&		Course::print(ostream& targetStream) const;
 *					// Display all course info on a stream
 * void			Course::kickOutStudents();
 *					// Deenroll all students
 */

Course::Course()
    : department(),
      courseNumber(0),
      meetingTime(),
      maxEnrollment(0),
      roster(NULL)
    {
    // ADD STUFF (PSEUDOCODE NOT NEEDED)
    }

Course::~Course()
    {
    /*
     * Before deleting the course, we must deenroll all students.
     */
    kickOutStudents();
    // ADD PSEUDOCODE
    }

void Course::fillInInfo(
    const string&	department_,
    int			courseNumber_,
    const string&	meetingTime_,
    int			maxEnrollment_)
    {
    // ADD PSEUDOCODE
    }

bool Course::isFull()
    const
    {
    // ADD PSEUDOCODE
    }

bool Course::courseIs(
    const string&	testDepartment,
    int			testNumber)
    const
    {
    // ADD PSEUDOCODE
    }

bool Course::addStudent(
    Student*		enrollee)
    {
    // ADD PSEUDOCODE
    }

bool Course::removeStudent(
    Student*		dropper)	// Student who is dropping the course
    {
    // ADD PSEUDOCODE
    }

void Course::changeMeetingTime(
    const string&	newMeetingTime)
    {
    // ADD STUFF (PSEUDOCODE NOT NEEDED)
    }

ostream& Course::showName(
    ostream&		targetStream)
    const
    {
    // ADD STUFF (PSEUDOCODE NOT NEEDED)
    return targetStream;
    }

ostream& Course::print(
    ostream&		targetStream)
    const
    {
    // ADD PSEUDOCODE
    return targetStream;
    }

void Course::kickOutStudents()		// Deenroll all students
    {
    // ADD PSEUDOCODE
    }
